/****************************************************************************
** $Id: application.h,v 1.5 1999/06/23 19:35:55 ettrich Exp $
**
** Copyright (C) 1992-1999 Troll Tech AS.  All rights reserved.
**
** This file is part of an example program for Qt.  This example
** program may be used, distributed and modified without limitation.
**
*****************************************************************************/

#ifndef APPLICATION_H
#define APPLICATION_H

#include <qmainwindow.h>

class Render2D;
class QToolBar;
class QPopupMenu;
class QScrollView;
class QToolButton;

class ApplicationWindow: public QMainWindow
{
    Q_OBJECT
public:
    ApplicationWindow();
    ~ApplicationWindow();
    
public slots:
	void SetStatusBar( QString );
  void load( const char *fileName );
	void CheckFont(int);
	void CheckSize(int);
	void Manual();

protected:
    void closeEvent( QCloseEvent* );

private slots:
    void newDoc();
    void load();
    void save();
    void saveAs();
    void saveAs(QString);
    void savePicture();
    void setModeSelect();
    void setDrawLine();
    void setDashLine();
    void setErase();
    void setText();
    void setFixed();
    void setArrow();
    void setUpLine();
    void setDownLine();
    void setBrackets();
    void OpenRingSubmenu();
    void OpenSymbolSubmenu();
    void pageSetup();
    void AlignHCenter();
    void AlignVCenter();
    void doAutoFormat();
    void showInfo();
    void formatOptions();
    void about();
    void blurb();

private:
    QPrinter *printer;
    Render2D *r;
		QScrollView *sv;
    QToolBar *fileTools, *drawTools;
    QString filename;
		QPopupMenu* format;
		QPopupMenu* ring_submenu;
		QPopupMenu* fontlist;
		QPopupMenu* fontsizelist;
		QToolButton* ringButton;
		int fixlen, f1, f2, f3, fs1, fs2, fs3, fs4, fs5, fs6;
};


#endif
