#ifndef CUSTOMOBJECT_H
#define CUSTOMOBJECT_H

#include <qcolor.h>
#include "dpoint.h"

class customObject
{
public:
	customObject();
	customObject(customObject *);
//	void Render(void);
	void setType(int);
	int Type(void) { return type; }
	void setSymbol(int s) { symbol = s; }
	int Symbol(void) { return symbol; }
	int Thickness(void);
	int LineWidth(void) { return lw; }
	void setThickness(int);
	void setLineWidth(int x) { lw = x; }
	void setFont(QFont);
	void addPoint(DPoint *);
	DPoint * getPoint1(void);
	DPoint * getPoint2(void);
	int getIndexOfPoint1(void);
	int getIndexOfPoint2(void);
	QString Label(void);
	void setLabel(QString);
	void setColor(const QColor c) { 
		color = c; 
		// Don't change highlighted objects right away...
		if (currentColor != QColor(255,0,0))
			currentColor = c;
	}
	void Print(void) {
		qWarning("%d,%d - %d,%d", p1->x(), p1->y(), p2->x(), p2->y());
	}
	void Highlight(void);
	void Unhighlight(void);
	int withinBounds(int, int, int, int);
	int onText(DPoint);
	int Dash() { return dashed; }
	void setDash(int i1) { dashed = i1; }
	// Is the given point part of this structure?
	int isMember(DPoint *n) {
	  if (n == p1) return true;
	  if (n == p2) return true;
	  return false;
	}
	DPoint * getOther(DPoint *n) {
	  if (n == p1) return p2;
	  return p1;
	}

// data
	DPoint *p1, *p2;
	QColor color;
	QColor currentColor;
	QString label;  // mostly for MTEXT but I guess any object may be labeled.
	QFont font;
	int dashed;
	int type;
	int symbol;  // if M_SYMBOL, which symbol?
	int hl;  // highlighted?
	int npoints;
	int thickness;  // single, double, or triple bond
	int lw;  // thickness of pen when drawing line

	int nrings; // number of rings this bond is in
	int rings[32];  // rings this bond is a member of
	int npolys; // number of polycyclic systems this bond is in
	int polycyclic[8]; // polycyclic systems this bond is a member of
};

#endif
