// mathematical constants
#define MOL_PI 3.14159247
//#define MOL_ARAD 57.29577951308232
#define MOL_ARAD 57.29578

// operating modes (e.g., Render2D::opmode)

#define MODE_SELECT  100
#define MODE_SELECT_DRAGPOINT  101
#define MODE_SELECT_MULTIPLE  110
#define MODE_MULTIPLE_SELECTION  120
#define MODE_DRAG_MULTIPLE_SELECTION 130
#define MODE_DRAG_LINE  140
#define MODE_ROTATE 150
#define MODE_RESIZE 160
#define MODE_DRAW_LINE  200
#define MODE_DRAWING_LINE  201
#define MODE_DASH_LINE  210
#define MODE_ERASE 202
#define MODE_TEXT 300
#define MODE_ARROW 400
#define MODE_UPLINE 500
#define MODE_DOWNLINE 600
#define MODE_BRACKETS 700

// Actions
#define DELETE_SELECTED  1
#define DELETE_MULTIPLE  2
#define ADD_OBJECT       3
#define UPDATE_TEXT      4
#define MOVE_OBJECT      5

// Object types
#define MLINE  100
#define MUPLINE 110
#define MDOWNLINE 120
#define MTEXT  200
#define MLABEL 300   // labels are text over a point
#define MARROW 400   // arrows are lines with an arrowhead
#define MBRACKET 500
#define MSYMBOL  600

// File types
#define MOL_NATIVE   0
#define MOL_PDB      1
#define MOL_MDL      2
#define MOL_CHEMDRAW 3
#define IMG_BMP 100
#define IMG_PNG 101
#define IMG_EPS 102

// number of bonds
#define SINGLE_BOND  1
#define DOUBLE_BOND  2
#define TRIPLE_BOND  3

// new or existing point?
#define OLD_POINT  0
#define NEW_POINT  1

// drawing modes
#define FREE_DRAWING  100
#define FIXED_DRAWING 200

// Rings
#define M_BENZENE        1
#define M_CYCLOHEXANE    2
#define M_CYCLOPENTANE   3
#define M_USERDEFINED    999

// Symbols
#define SYM_DELTA_MINUS    1
#define SYM_DELTA_PLUS     2
#define SYM_MINUS          3
#define SYM_PLUS           4
#define SYM_RADICAL1       5
#define SYM_RADICAL2       6
#define SYM_RADICAL_MINUS  7
#define SYM_RADICAL_PLUS   8

// Print options
#define PAGE_LANDSCAPE  1
#define PAGE_PORTRAIT   2
#define PAGE_LETTER     10
#define PAGE_LEGAL      11
#define PAGE_A4         12
#define PAGE_USERDEFINE 13

// Fonts and sizes
#define FONT_COURIER    1
#define FONT_HELVETICA  2
#define FONT_TIMES      3
#define FONT_8  1
#define FONT_10 2
#define FONT_12 3
#define FONT_14 4
#define FONT_18 5
#define FONT_24 6

// Alignment directions
#define ALIGN_TOP     1
#define ALIGN_BOTTOM  2
#define ALIGN_LEFT    3
#define ALIGN_RIGHT   4
#define ALIGN_HCENTER 5
#define ALIGN_VCENTER 6

// Directions (for flip)
#define HORIZONTAL_AXIS 1
#define VERTICAL_AXIS   2
