#ifndef DPOINT_H
#define DPOINT_H

#include <math.h>

class DPoint {
 public:
  DPoint() { x1 = 0.0; y1 = 0.0; iamanatom = false; }
  DPoint(QPoint q) { 
    x1 = q.x(); y1 = q.y(); 
    iamanatom = false;
    c1 = QColor(0,0,0);
    name = QString("C");
  }
  DPoint(int a, int b) { 
    x1 = (double)a; y1 = (double)b; 
    iamanatom = false;
    c1 = QColor(0,0,0);
    name = QString("C");
  }
  DPoint(int a, double b) { 
    x1 = (double)a; y1 = b; 
    iamanatom = false;
    c1 = QColor(0,0,0);
    name = QString("C");
  }
  DPoint(double a, int b) { 
    x1 = a; y1 = (double)b; 
    iamanatom = false;
    c1 = QColor(0,0,0);
    name = QString("C");
  }
  DPoint(double a, double b) { 
    x1 = a; y1 = b; 
    iamanatom = false;
    c1 = QColor(0,0,0);
    name = QString("C");
  }
  void setX(double a) { x1 = a; }
  void setX(int a) { x1 = (double)a; }
  void setY(double b) { y1 = b; }
  void setY(int b) { y1 = (double)b; }
  void setColor(const QColor c) { c1 = c; }
  void setRadius(double n) { radius = n; }
  double x() { return x1; }
  double y() { return y1; }
  QColor color() { return c1; }
  int xint() { return (int)x1; }
  int yint() { return (int)y1; }
  int isAtom() { return iamanatom; }
  void isAtom(int x) { iamanatom = x; }
  double Radius() { return radius; }
  QPoint toQPoint() { return QPoint((int)x1, (int)y1); }	
  double distanceToPoint(DPoint b) {
    double dx = b.x1 - x1;
    double dy = b.y1 - y1;
    return sqrt(dx*dx + dy*dy);
  }
  double distanceToPoint(QPoint b) {
    double dx = (double)b.x() - x1;
    double dy = (double)b.y() - y1;
    return sqrt(dx*dx + dy*dy);
  }
  DPoint operator-(DPoint b) {
    DPoint c;
    c.x1 = x1 - b.x1;
    c.y1 = y1 - b.y1;
    return c;
  }
  // get/set number of hydrogens (usually invisible)
  int Hydrogens() { return num_h; }
  void setHydrogens(int n) { 
    num_h = n;
    // eliminate cases where adding H might be inappropriate
    if (name.find("H") >= 0) num_h = 0;
    if (name.at(name.length() - 1).isNumber()) num_h = 0;
    int ptr = 0;
    if (name.at(ptr).isNumber() == true) ptr++;
    if (name.at(ptr).isNumber() == true) ptr++;
    if (name.at(ptr).isNumber() == true) ptr++;
    if ((name.length() - ptr) > 2) num_h = 0;
  }
  // get/set point name
  QString Name() { return name; }
  void setName(QString t) { name = t; }
  // group id for formatting, etc. (probably should be private)
  int gid;
  QString id;  // CML ID (should be private...)
  int nrings; // number of rings this atom is in
  int rings[32];  // rings this atom is a member of
  int npolys; // number of polycyclic systems this atom is in
  int polycyclic[8]; // polycyclic systems this atom is a member of

 private:
  // string of element/group this point represents (if atom)
  QString name;
  // position
  double x1;
  double y1;
  // color
  QColor c1;
  double radius;
  // is this point an atom, true or false...
  int iamanatom;
  // number of hydrogens attached, if this is an atom
  int num_h;
};

#endif
