#include <qwidget.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qdialog.h>
#include <qcolor.h>
#include <qfont.h>
#include <qnamespace.h>

#include "render2d.h"
#include "infodialog.h"

void Render2D::showInfo(void) {
  InfoDialog i(this, QString("info_dialog"));
  i.setTitle(MoleculeTitle);
  i.setID(MoleculeId);
  if ( !i.exec() ) return;
  MoleculeTitle = i.getTitle();
  MoleculeId = i.getID();
}

InfoDialog::InfoDialog(QWidget *parent, QString name) : 
	QDialog(parent, name, TRUE)
{
  QPushButton *ok, *cancel;
  QLabel *t1, *t2;
  setBackgroundColor(lightGray);
  setCaption(QString("Information"));
  t1 = new QLabel("Molecule ID", this);
  t1->setGeometry(10,10,100,30);
  t1->setBackgroundColor(lightGray);
  t2 = new QLabel("Molecule Title", this);
  t2->setGeometry(10,50,100,30);
  t2->setBackgroundColor(lightGray);
  tf_id = new QLineEdit(this);
  tf_id->setGeometry(120,10,200,30);
  tf_title = new QLineEdit(this);
  tf_title->setGeometry(120,50,200,30);
  ok = new QPushButton("OK", this);
  ok->setGeometry(10,90,100,30);
  ok->setPalette(QPalette(lightGray));
  connect(ok, SIGNAL(clicked()), SLOT(accept()) );
  cancel = new QPushButton("Cancel", this);
  cancel->setGeometry(120,90,100,30);
  cancel->setPalette(QPalette(lightGray));
  connect(cancel, SIGNAL(clicked()), SLOT(reject()) );
}

void InfoDialog::setID(QString t)
{
  tf_id->setText(t);
}

void InfoDialog::setTitle(QString t)
{
  tf_title->setText(t);
}

QString InfoDialog::getID(void)
{
  return tf_id->text();
}

QString InfoDialog::getTitle(void)
{
  return tf_title->text();
}
