#include <qwidget.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qdialog.h>
#include <qcolor.h>
#include <qfont.h>
#include <qnamespace.h>

#include "labeldialog.h"

LabelDialog::LabelDialog(QWidget *parent, QString name, QString caption) : 
	QDialog(parent, name, TRUE)
{
	QPushButton *ok, *cancel;
	QLabel *textmsg;
	setBackgroundColor(lightGray);
	setCaption(QString("Text tool"));
	textmsg = new QLabel(caption, this);
	textmsg->setGeometry(10,10,200,30);
	textmsg->setBackgroundColor(lightGray);
	textfield = new QLineEdit(this);
	textfield->setGeometry(10,50,200,30);
	connect(textfield, SIGNAL(returnPressed()), SLOT(accept()) );
	ok = new QPushButton("OK", this);
	ok->setGeometry(10,90,100,30);
	ok->setPalette(QPalette(lightGray));
	connect(ok, SIGNAL(clicked()), SLOT(accept()) );
	cancel = new QPushButton("Cancel", this);
	cancel->setGeometry(120,90,100,30);
	cancel->setPalette(QPalette(lightGray));
	connect(cancel, SIGNAL(clicked()), SLOT(reject()) );
}

void LabelDialog::setText(QString t)
{
	textfield->setText(t);
}

void LabelDialog::setFont(QFont t)
{
	textfield->setFont(t);
}

QString LabelDialog::getText(void)
{
	return textfield->text();
}
