/****************************************************************************
** $Id: main.cpp,v 1.4 1999/06/10 19:20:40 agulbra Exp $
**
** Copyright (C) 1992-1999 Troll Tech AS.  All rights reserved.
**
** This file is part of an example program for Qt.  This example
** program may be used, distributed and modified without limitation.
**
*****************************************************************************/

#include <qapplication.h>
#include <qpixmap.h>
#include <qlist.h>
#include "application.h"
#include "mclipboard.h"

// symbols
#include "sym_delta_minus.xpm"
#include "sym_delta_plus.xpm"
#include "sym_minus.xpm"
#include "sym_plus.xpm"
#include "sym_radical1.xpm"
#include "sym_radical2.xpm"
#include "sym_radical_plus.xpm"
#include "sym_radical_minus.xpm"

QList<QPixmap> DSymbolTable;

MClipboard clipboard;

int main( int argc, char ** argv ) {
	QPixmap *p;
  QApplication a( argc, argv );
  ApplicationWindow * mw = new ApplicationWindow();
  mw->show();
	if (argc > 1) {
		mw->load( argv[1] );
	}
  a.connect( &a, SIGNAL(lastWindowClosed()), &a, SLOT(quit()) );

	// Create symbol table
	p = new QPixmap(sym_delta_minus);
	DSymbolTable.append(p);
	p = new QPixmap(sym_delta_plus);
	DSymbolTable.append(p);
	p = new QPixmap(sym_minus);
	DSymbolTable.append(p);
	p = new QPixmap(sym_plus);
	DSymbolTable.append(p);
	p = new QPixmap(sym_radical1);
	DSymbolTable.append(p);
	p = new QPixmap(sym_radical2);
	DSymbolTable.append(p);
	p = new QPixmap(sym_radical_minus);
	DSymbolTable.append(p);
	p = new QPixmap(sym_radical_plus);
	DSymbolTable.append(p);

  return a.exec();
}
