#ifndef QMATH_H
#define QMATH_H

#include "defs.h"
#include "dpoint.h"

class QMath {
public:
	QMath() { }
	double getDistance(DPoint a, DPoint b)
	{
		DPoint c = b - a;

		return sqrt(c.x()*c.x() + c.y()*c.y());
	}

	double getAngle(DPoint a, DPoint b)
	{
		double angle;
		DPoint c = b - a;
		
		if (c.x() == 0) return 90.0;
		angle = atan(c.y()/c.x())*MOL_ARAD;

		if (angle < 0.0) angle*=-1.0;

		if (b.x() > a.x() && b.y() > a.y()) angle = 0.0 + angle;
		if (b.x() < a.x() && b.y() > a.y()) angle = 180.0 - angle;
		if (b.x() < a.x() && b.y() < a.y()) angle = 180.0 + angle;
		if (b.x() > a.x() && b.y() < a.y()) angle = 360.0 - angle;

		return angle;
	}
};

#endif
