#include <math.h>
#include <iostream.h>
#include <qpainter.h>
#include <qimage.h>
#include <qevent.h>
#include <qlist.h>
#include <math.h>
#include <qbitmap.h>
#include <qcursor.h>
#include <qdialog.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qpointarray.h>
#include <qprinter.h>
#include <qmessagebox.h>
#include <qpaintdevicemetrics.h>
#include <qnamespace.h>

#include "render2d.h"
#include "defs.h"
#include "dpoint.h"

void Render2D::addRing(int which, int x, int y, QString rfn)
{
  //	qWarning("%d: (%d,%d)", which, x, y);
  DPoint *p1, *p2, *p3, *p4, *p5, *p6, *ptmp;
  customObject *t1;
  double sf = fixedLength / 10.0;

	// Deselect all when adding a ring
  setCursor(arrowCursor);
  deselectAll();

  switch (which) {
  case M_BENZENE:
    p1 = new DPoint(x+(5.0*sqrt(3.0)*sf), (double)y);
    p2 = new DPoint(x+(10.0*sqrt(3.0)*sf),
		    y + 5 * sf);
    p3 = new DPoint(x+(10.0*sqrt(3.0)*sf),
		    y + 15 * sf);
    p4 = new DPoint(x+(5.0*sqrt(3.0)*sf),
		    y + 20 * sf);
    p5 = new DPoint(x, y + 15 * sf);
    p6 = new DPoint(x,y + 5 * sf);
    p1->isAtom(true); p2->isAtom(true); p3->isAtom(true);
    p4->isAtom(true); p5->isAtom(true); p6->isAtom(true);
    selectPointList.append(p1); pointList.append(p1);
    selectPointList.append(p2); pointList.append(p2);
    selectPointList.append(p3); pointList.append(p3);
    selectPointList.append(p4); pointList.append(p4);
    selectPointList.append(p5); pointList.append(p5);
    selectPointList.append(p6); pointList.append(p6);
    t1 = new customObject;
    t1->setType(MLINE);
    t1->addPoint(p1);
    t1->addPoint(p2);
    t1->Highlight();
    t1->setColor(currentColor);
    selectList.append(t1); objectList.append(t1);
    t1 = new customObject;
    t1->setType(MLINE);
    t1->addPoint(p2);
    t1->addPoint(p3);
    t1->setThickness(DOUBLE_BOND);
    t1->Highlight();
    t1->setColor(currentColor);
    selectList.append(t1); objectList.append(t1);
    t1 = new customObject;
    t1->setType(MLINE);
    t1->addPoint(p3);
    t1->addPoint(p4);
    t1->Highlight();
    t1->setColor(currentColor);
    selectList.append(t1); objectList.append(t1);
    t1 = new customObject;
    t1->setType(MLINE);
    t1->addPoint(p4);
    t1->addPoint(p5);
    t1->setThickness(DOUBLE_BOND);
    t1->Highlight();
    t1->setColor(currentColor);
    selectList.append(t1); objectList.append(t1);
    t1 = new customObject;
    t1->setType(MLINE);
    t1->addPoint(p5);
    t1->addPoint(p6);
    t1->Highlight();
    t1->setColor(currentColor);
    selectList.append(t1); objectList.append(t1);
    t1 = new customObject;
    t1->setType(MLINE);
    t1->addPoint(p6);
    t1->addPoint(p1);
    t1->setThickness(DOUBLE_BOND);
    t1->Highlight();
    t1->setColor(currentColor);
    selectList.append(t1); objectList.append(t1);
    break;

  case M_CYCLOHEXANE:
    p1 = new DPoint(x+(5.0*sqrt(3.0)*(double)sf), (double)y);
    p2 = new DPoint(x+(10.0*sqrt(3.0)*(double)sf),
		    y + 5 * sf);
    p3 = new DPoint(x+(10.0*sqrt(3.0)*(double)sf),
		    y + 15 * sf);
    p4 = new DPoint(x+(5.0*sqrt(3.0)*(double)sf),
		    y + 20 * sf);
    p5 = new DPoint(x, y + 15 * sf);
    p6 = new DPoint(x,y + 5 * sf);
    p1->isAtom(true); p2->isAtom(true); p3->isAtom(true);
    p4->isAtom(true); p5->isAtom(true); p6->isAtom(true);
    selectPointList.append(p1); pointList.append(p1);
    selectPointList.append(p2); pointList.append(p2);
    selectPointList.append(p3); pointList.append(p3);
    selectPointList.append(p4); pointList.append(p4);
    selectPointList.append(p5); pointList.append(p5);
    selectPointList.append(p6); pointList.append(p6);
    t1 = new customObject;
    t1->setType(MLINE);
    t1->addPoint(p1);
    t1->addPoint(p2);
    t1->Highlight();
    t1->setColor(currentColor);
    selectList.append(t1); objectList.append(t1);
    t1 = new customObject;
    t1->setType(MLINE);
    t1->addPoint(p2);
    t1->addPoint(p3);
    t1->Highlight();
    t1->setColor(currentColor);
    selectList.append(t1); objectList.append(t1);
    t1 = new customObject;
    t1->setType(MLINE);
    t1->addPoint(p3);
    t1->addPoint(p4);
    t1->Highlight();
    t1->setColor(currentColor);
    selectList.append(t1); objectList.append(t1);
    t1 = new customObject;
    t1->setType(MLINE);
    t1->addPoint(p4);
    t1->addPoint(p5);
    t1->Highlight();
    t1->setColor(currentColor);
    selectList.append(t1); objectList.append(t1);
    t1 = new customObject;
    t1->setType(MLINE);
    t1->addPoint(p5);
    t1->addPoint(p6);
    t1->Highlight();
    t1->setColor(currentColor);
    selectList.append(t1); objectList.append(t1);
    t1 = new customObject;
    t1->setType(MLINE);
    t1->addPoint(p6);
    t1->addPoint(p1);
    t1->Highlight();
    t1->setColor(currentColor);
    selectList.append(t1); objectList.append(t1);
    break;

  case M_CYCLOPENTANE:
    p1 = new DPoint(x+8.09*sf,(double)y);
    p2 = new DPoint(x+16.18*sf,y+5.8779*sf);
    p3 = new DPoint(x+13.09*sf,y+15.3879*sf);
    p4 = new DPoint(x+3.09*sf,y+15.3879*sf);
    p5 = new DPoint(x,y+5.8779*sf);
    p1->isAtom(true); p2->isAtom(true); p3->isAtom(true);
    p4->isAtom(true); p5->isAtom(true);
    selectPointList.append(p1); pointList.append(p1);
    selectPointList.append(p2); pointList.append(p2);
    selectPointList.append(p3); pointList.append(p3);
    selectPointList.append(p4); pointList.append(p4);
    selectPointList.append(p5); pointList.append(p5);
    t1 = new customObject;
    t1->setType(MLINE);
    t1->addPoint(p1);
    t1->addPoint(p2);
    t1->Highlight();
    t1->setColor(currentColor);
    selectList.append(t1); objectList.append(t1);
    t1 = new customObject;
    t1->setType(MLINE);
    t1->addPoint(p2);
    t1->addPoint(p3);
    t1->Highlight();
    t1->setColor(currentColor);
    selectList.append(t1); objectList.append(t1);
    t1 = new customObject;
    t1->setType(MLINE);
    t1->addPoint(p3);
    t1->addPoint(p4);
    t1->Highlight();
    t1->setColor(currentColor);
    selectList.append(t1); objectList.append(t1);
    t1 = new customObject;
    t1->setType(MLINE);
    t1->addPoint(p4);
    t1->addPoint(p5);
    t1->Highlight();
    t1->setColor(currentColor);
    selectList.append(t1); objectList.append(t1);
    t1 = new customObject;
    t1->setType(MLINE);
    t1->addPoint(p5);
    t1->addPoint(p1);
    t1->Highlight();
    t1->setColor(currentColor);
    selectList.append(t1); objectList.append(t1);
    break;

  case M_USERDEFINED:
    QString rpath = QString(RINGHOME);
    if (rpath.right(1) != QString("/"))
      rpath.append(QString("/"));
    QString fullname = rpath + rfn;

    // debug
    //qWarning("%s", fullname.ascii());

    QFile f(fullname);
    if (!f.open(IO_ReadOnly)) {
      QMessageBox::warning(this, "Couldn't read template", 
			   "Unable to open the specified template.");
      return;
    }
    QTextStream t(&f);
    QString line = t.readLine();
    QString tmpline, tfont;
    DPoint *newpt;
    customObject *newobj;
    int d1, d2, d3, d4, tpt;
    int offset = pointList.count();
    double l1, l2, l3, l4;
    double sf = fixedLength / 10.0;
    if (line == "XDRAWCHEM-TEMPLATE-1.0") {
      do {
	line = t.readLine();
	QTextIStream(&line) >> tmpline;
	if (tmpline == "POINT") {
	  QTextIStream(&line) >> tmpline >> d1 >> l2 >> l3;
	  // do scaling here
	  newpt = new DPoint((l2*sf)+(double)x, (l3*sf)+(double)y);
	  newpt->isAtom(true);
	  pointList.append(newpt);
	  selectPointList.append(newpt);
	}
	if (tmpline == "LINE") {
	  QTextIStream(&line) >> tmpline >> d1 >> d2 >> d3 >> d4;
	  newobj = new customObject;
	  newobj->setType(MLINE);
	  newobj->addPoint(pointList.at(d1+offset));
	  newobj->addPoint(pointList.at(d2+offset));
	  pointList.at(d1)->isAtom(true);
	  pointList.at(d2)->isAtom(true);
	  newobj->setThickness(d3);
	  newobj->setLineWidth(d4);
	  newobj->Highlight();
	  objectList.append(newobj);
	  selectList.append(newobj);
	}
	if (tmpline == "UPLINE") {
	  QTextIStream(&line) >> tmpline >> d1 >> d2 >> d3;
	  newobj = new customObject;
	  newobj->setType(MUPLINE);
	  newobj->addPoint(pointList.at(d1+offset));
	  newobj->addPoint(pointList.at(d2+offset));
	  pointList.at(d1)->isAtom(true);
	  pointList.at(d2)->isAtom(true);
	  newobj->setThickness(d3);
	  newobj->Highlight();
	  objectList.append(newobj);
	  selectList.append(newobj);
	}
	if (tmpline == "DOWNLINE") {
	  QTextIStream(&line) >> tmpline >> d1 >> d2 >> d3;
	  newobj = new customObject;
	  newobj->setType(MDOWNLINE);
	  newobj->addPoint(pointList.at(d1+offset));
	  newobj->addPoint(pointList.at(d2+offset));
	  pointList.at(d1)->isAtom(true);
	  pointList.at(d2)->isAtom(true);
	  newobj->setThickness(d3);
	  newobj->Highlight();
	  objectList.append(newobj);
	  selectList.append(newobj);
	}
	if (tmpline == "LABEL") {
	  QTextIStream(&line) >> tmpline >> d1 >> tfont >> tpt;
	  tmpline = line.mid(line.find('`') + 1);
	  newobj = new customObject;
	  newobj->setType(MLABEL);
	  newobj->addPoint(pointList.at(d1+offset));
	  newobj->setLabel(tmpline);
	  newobj->setFont(QFont(tfont, tpt));
	  newobj->Highlight();
	  objectList.append(newobj);
	  selectList.append(newobj);
	  if (tmpline == QString("H")) pointList.at(d1)->setName("H");
	  if (tmpline == QString("N")) pointList.at(d1)->setName("N");
	  if (tmpline == QString("O")) pointList.at(d1)->setName("O");
	}
      } while (!t.atEnd());
      f.close();
      emit UpdateStatusBar(QString("Loaded ring ") + QString(rfn));		
    } else {
      QMessageBox::warning(this, "Couldn't read template", 
			   "The specified template is not formatted correctly.");
      return;
    }
    break;
  }
  opmode = MODE_MULTIPLE_SELECTION;

	// create resize handle for this ring
  double x1, y1, x2, y2;
  x1 = 99999.0; x2 = 0.0; y1 = 99999.0; y2 = 0.0;
  for (ptmp=selectPointList.first(); ptmp != 0; ptmp=selectPointList.next()) {
    if (ptmp->x() < x1) x1 = ptmp->x();
    if (ptmp->x() > x2) x2 = ptmp->x();
    if (ptmp->y() < y1) y1 = ptmp->y();
    if (ptmp->y() > y2) y2 = ptmp->y();
  }
  resizeOrigin = new DPoint(x1, y1);
  resizeHandle = new DPoint(x2, y2);

  repaint();
}
