#ifndef TEXTDIALOG_H
#define TEXTDIALOG_H

#include <qmultilineedit.h>
#include <qdialog.h>
#include <qwidget.h>

// The preview widget
class TextPreviewWidget:public QWidget {
  Q_OBJECT
    public:
  TextPreviewWidget(QFont fs, QWidget *parent=0, const char *name = 0);
  void Update(QString);
  QFont myfont;
};

// My QMultiLineEdit -- so I can accesss *&*^&%$?!! protected members
class MyEditor:public QMultiLineEdit {
  Q_OBJECT
    public:
  MyEditor(QWidget *parent=0, const char *name = 0);
  bool viewMarkedRegion(int *, int *, int *, int *);
  void Format(int);
};

// The text dialog
class TextDialog:public QDialog {
	Q_OBJECT
public:
	TextDialog(QWidget *parent, QString name, QString caption, QFont fs);
	QString getText(void);
	void setText(QString);
	void setFont(QFont);

private slots:
	  void PreviewText(void);
 void setSuper(void);
 void setSub(void);

private:
 MyEditor *textfield;
 TextPreviewWidget *tpw;
};

#endif
